package
{
	import flash.display.Bitmap;
	import flash.geom.Point;
	import flash.ui.Mouse;
	
	import flashx.textLayout.formats.BackgroundColor;
	import flashx.textLayout.operations.RedoOperation;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class GameState extends FlxState
	{
		
		[Embed(source="data/tile.png")]
		public static var ImgTile:Class;
		
		[Embed(source="data/notea.mp3")]
		public static var SndA:Class;
		[Embed(source="data/noteb.mp3")]
		public static var SndB:Class;
		[Embed(source="data/notec.mp3")]
		public static var SndC:Class;
		private var talking:Boolean=false;
		public var grp:FlxGroup;
		
		public var px:int=0;
		public var py:int=0;
		
		public var levelstr:Array = [
			".....######.....",
			".....#....#.....",
			".....#.3..#.....",
			".....#....#.....",
			".....##..##.....",
			"#####.#..#.#####",
			"#...###..###...#",
			"#.2.........1..#",
			"#..............#",
			"#...###.####...#",
			"#####.#.#..####.",
			"......#.#.......",
			"......#.########",
			"......#..DDD...#",
			"......#.######.#",
			"......#.#.#....#",
			"......#.#.#.P..#",
			"......#.#.#....#",
			"......#S#.######",
			"......###......."];
		
		public var level:Array;
		
		public function DrawMap():void
		{
			bgg.remove(grp,true);
			grp = new FlxGroup();
			
			for (var j:int=0;j<level.length;j++)
			{
				for (var i:int=0;i<level[j].length;i++)
				{
					if (i==px && j==py)
					{
						s=  new FlxSprite(i*15,j*15,ImgTile);
						s.loadGraphic(ImgTile,true,false,15,15);
						s.addAnimation("main",[2],0,false);
						s.play("main");
						grp.add(s);
					}
					else
					{
						var s:FlxSprite=  new FlxSprite(i*15,j*15,ImgTile);
						s.loadGraphic(ImgTile,true,false,15,15);
						s.addAnimation("main",[level[j][i]],0,false);
						s.play("main");
						grp.add(s);
					}
				}
			}
			var t:FlxText = new FlxText(2,2,FlxG.width,keycount+" keys");
			t.color = 0xffffffff;
			grp.add(t);
			bgg.add(grp);
			SetTalkText("");
		}
		
		private var bgg:FlxGroup;
		
		override public function create():void
		{
			level=[];
			for (var i:int=0;i<levelstr.length;i++)
			{
				var row:Array = [];
				for (var j:int=0;j<levelstr[i].length;j++)
				{
					if (levelstr[i].charAt(j)=="S")
					{
						py=i;
						px=j;
						row.push(0);						
					}
					else
					{
						var num:int =".FS#123PD".indexOf(levelstr[i].charAt(j));
						row.push(num);
					}
				}
				level.push(row);
			}
			grp = new FlxGroup();
			bgg = new FlxGroup();
			bgg.add(grp);
			add(bgg);
			talktexts = new Vector.<FlxText>();
		
			var talktext:FlxText;
			talktext = new FlxText(0,FlxG.height/3-4+1,FlxG.width,"If you swear to me to never again in your life to move east, I will give you this key");
			talktext.size=16;	
			talktext.color=0x000000;
			add(talktext);
			talktexts.push(talktext);
			
			var talktext:FlxText;
			talktext = new FlxText(0,FlxG.height/3-4-1,FlxG.width,"If you swear to me to never again in your life to move east, I will give you this key");
			talktext.size=16;	
			talktext.color=0x000000;
			add(talktext);
			talktexts.push(talktext);
			
			var talktext:FlxText;
			talktext = new FlxText(0+1,FlxG.height/3-4,FlxG.width,"If you swear to me to never again in your life to move east, I will give you this key");
			talktext.size=16;	
			talktext.color=0x000000;
			add(talktext);
			talktexts.push(talktext);
			
			var talktext:FlxText;
			talktext = new FlxText(0-1,FlxG.height/3-4,FlxG.width,"If you swear to me to never again in your life to move east, I will give you this key");
			talktext.size=16;	
			talktext.color=0x000000;
			add(talktext);
			talktexts.push(talktext);
			
			var talktext:FlxText;
			talktext = new FlxText(0,FlxG.height/3-4,FlxG.width,"If you swear to me to never again in your life to move east, I will give you this key");
			talktext.size=16;	
			add(talktext);
			talktexts.push(talktext);
			
			SetTalkText("");
			DrawMap();
			
		}
		
		private function SetTalkText(s:String):void
		{
			for (var i:int=0;i<talktexts.length;i++)
			{
				talktexts[i].visible=s!="";
				talktexts[i].alignment="center";
				talktexts[i].text = s;
			}
		}
		
		private var talktexts:Vector.<FlxText>;
		
		override public function update():void
		{
			super.update();
			
			if(FlxG.keys.justPressed("R"))
			{
				FlxG.state = new GameState();
				return;
			}	
			if (talking)
			{
				if (FlxG.keys.justPressed("RIGHT"))
				{
					if (talkmode<=3)
					{
						oathtaken[talkmode]=true;
						talking=false;
						SetTalkText("");
						keycount++;
						DrawMap();
					}
					else
					{						
						FlxG.state = new EndState();
					}
				}
				if (FlxG.keys.justPressed("LEFT"))
				{
					if (talkmode<=3)
					{
						oathtaken[talkmode]=false;
						talking=false;
						SetTalkText("");
						DrawMap();					
					}	
					else
					{
						FlxG.state = new EndState();
					}				
				}
				return;
			}
			
			if (FlxG.keys.justPressed("LEFT"))
			{
				TryMove(-1,0);
			}
			if (FlxG.keys.justPressed("RIGHT"))
			{
				TryMove(1,0);
			}
			if (FlxG.keys.justPressed("UP"))
			{
				TryMove(0,-1);
			}
			if (FlxG.keys.justPressed("DOWN"))
			{
				TryMove(0,1);
			}
		}
		
		private var lastmove:int=-1;
		
		public var keycount:int=0;
		private var talkmode:int=0;
		public function TryMove(x:int,y:int):void
		{
			x=x+px;
			y=y+py;
			var thismove:int = x<px?1
				:  x>px?2
				:  y<py?3
				:  y>py?4
				:0;
			switch (level[y][x])
			{
				case 0:
					if (x>px)
					{
						BreakOath(1);
					}
					level[py][px]=1;
					px=x;
					py=y;
					if (thismove==lastmove&&thismove!=0)
						BreakOath(3);
					lastmove=thismove;
					DrawMap();
					break;
				case 1:
					if (x>px)
					{
						BreakOath(1);
					}
					level[py][px]=1;
					BreakOath(2);
					px=x;
					py=y;	
					if (thismove==lastmove&&thismove!=0)
						BreakOath(3);
					lastmove=thismove;
					DrawMap();				
					break;
				case 2:
					//player,nothing
					break;
				case 3:
					//wall...NOTHING
					break;
				case 4:
					if (oathtaken[1]==0)
					{
						talking=true;					
						talkmode=1;
						SetTalkText("If you swear to me to never again in your life to move east, I will give you this key\n\nRIGHT to accept\nLEFT to cancel.");
						if (oathbreaker)
						{
							talking=false;
							SetTalkText("You are not a man of your word.  I have no time for you.");
						}
					}
					//oath1
					break;
				case 5:
					//oath2
					if (oathtaken[2]==0)
					{
						talking=true;
						talkmode=2;
						SetTalkText("If you promise to me that you will at no point in the future tread the same ground twice, I will give you this key\n\nRIGHT to accept\nLEFT to cancel.");
						if (oathbreaker)
						{
							talking=false;
							SetTalkText("You are not a man of your word.  I have no time for you.");
						}
					}
					break;
				case 6:
					//oath3
					if (oathtaken[3]==0)
					{
						talking=true;
						talkmode=3;
						SetTalkText("If you give me your word that you will never again move the same direction two times in a row, I will give you  you this key\n\nRIGHT to accept\nLEFT to cancel.");
						if (oathbreaker)
						{
							talking=false;
							SetTalkText("You are not a man of your word.  I have no time for you.");
						}
					}
					break;
				case 7:
					//girl
					talking=true;
					talkmode=4;
					SetTalkText("My hero!  Bless you for saving me.  Swear on your heart that you love me, and we can be together forever at last!\n\nRIGHT to swear\nLEFT to refuse.");
					break;
				case 8:
					//door	
					if (keycount>0)
					{
						level[py][px]=1;
						level[y][x]=0;
						keycount--;
						px=x;
						py=y;
						if (thismove==lastmove&&thismove!=0)
							BreakOath(3);
						lastmove=thismove;
						DrawMap();
					}
					break;
				
			}
		}
		
		private var oathbreaker:Boolean=false;
		private var oathtaken:Array=[0,0,0,0];
		private function BreakOath(onum:int):void
		{
			switch(onum)
			{
				case 1:
					FlxG.play(SndA);
					break;
				case 2:
					FlxG.play(SndB);
					break;
				case 3:
					FlxG.play(SndC);
					break;
			}
			if (oathtaken[onum]==1)
			{
				oathbreaker=true;
				trace("broken " + onum);
			}
			else
			{
				trace("not broken " + onum);
			}
		}
	}
}